<?xml version="1.0"?>

<!-- Copyright (C) 2000, HELM Team                                     -->
<!--                                                                   -->
<!-- This file is part of HELM, an Hypertextual, Electronic            -->
<!-- Library of Mathematics, developed at the Computer Science         -->
<!-- Department, University of Bologna, Italy.                         -->
<!--                                                                   -->
<!-- HELM is free software; you can redistribute it and/or             -->
<!-- modify it under the terms of the GNU General Public License       -->
<!-- as published by the Free Software Foundation; either version 2    -->
<!-- of the License, or (at your option) any later version.            -->
<!--                                                                   -->
<!-- HELM is distributed in the hope that it will be useful,           -->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of    -->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     -->
<!-- GNU General Public License for more details.                      -->
<!--                                                                   -->
<!-- You should have received a copy of the GNU General Public License -->
<!-- along with HELM; if not, write to the Free Software               -->
<!-- Foundation, Inc., 59 Temple Place - Suite 330, Boston,            -->
<!-- MA  02111-1307, USA.                                              -->
<!--                                                                   -->
<!-- For details, see the HELM World-Wide-Web page,                    -->
<!-- http://cs.unibo.it/helm/.                                         -->

<!--***********************************************************************--> 
<!-- XSLT version 0.1 of annotated MathML content to MathML presentation:  -->
<!-- First draft: March 29 2000, Claudio Sacerdoti Coen, Irene Schena      -->
<!--***********************************************************************--> 

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                              xmlns:m="http://www.w3.org/1998/Math/MathML"
                              xmlns:helm="http://www.cs.unibo.it/helm">

<xsl:import href="mmlextension.xsl"/>

<!-- ANNOTATION -->

<xsl:template match="annotation">
    <xsl:choose>
    <xsl:when test=". = /">
      <m:math><m:mrow helm:xref="{@helm:xref}"><xsl:apply-templates/></m:mrow></m:math>
    </xsl:when>
    <xsl:otherwise>
     <m:mrow helm:xref="{@helm:xref}"><xsl:apply-templates/></m:mrow>
    </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="text()">
 <xsl:variable name="text" select="normalize-space(.)"/>
 <xsl:if test="$text != ''">
  <m:mtext><xsl:value-of select="$text"/></m:mtext>
 </xsl:if>
</xsl:template>

</xsl:stylesheet> 
