<?xml version="1.0"?>

<!--******************************************************************--> 
<!-- Basic Logic                                                      -->
<!-- First draft: April 3 2000                                        -->
<!-- HELM Group: Asperti, Padovani, Sacerdoti, Schena                 -->
<!--******************************************************************-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                              xmlns:m="http://www.w3.org/1998/Math/MathML"
                              xmlns:helm="http://www.cs.unibo.it/helm">

<!--******************************************************************-->
<!-- Variable containing the absolute path of the CIC file            -->
<!--******************************************************************-->

<xsl:variable name="absPath">http://localhost:8081/get?url=</xsl:variable>

<!-- ************************* LOGIC *********************************-->

<!-- AND -->

<xsl:template match="APPLY[MUTIND[attribute::uri='cic:/coq/INIT/Logic/Conjunction/and.ind'] and (count(child::*) = 3)]" mode="noannot">
    <m:apply helm:xref="{@id}">
    <m:and definitionURL="{MUTIND/@uri}" helm:xref="{MUTIND/@id}"/>
     <xsl:apply-templates select="*[2]" mode="noannot"/>
     <xsl:apply-templates select="*[3]" mode="noannot"/>
    </m:apply>
</xsl:template>

<!-- OR -->

<xsl:template match="APPLY[MUTIND[attribute::uri='cic:/coq/INIT/Logic/Disjunction/or.ind'] and (count(child::*) = 3)]" mode="noannot">
    <m:apply helm:xref="{@id}">
    <m:or definitionURL="{MUTIND/@uri}" helm:xref="{MUTIND/@id}"/>
     <xsl:apply-templates select="*[2]" mode="noannot"/>
     <xsl:apply-templates select="*[3]" mode="noannot"/>
    </m:apply>
</xsl:template>

<!-- NOT -->

<xsl:template match="APPLY[CONST[attribute::uri='cic:/coq/INIT/Logic/not.con'] and (count(child::*) = 2)]" mode="noannot">
    <m:apply helm:xref="{@id}">
    <m:not definitionURL="{CONST/@uri}" helm:xref="{MUTIND/@id}"/>
     <xsl:apply-templates select="*[2]" mode="noannot"/>
    </m:apply>
</xsl:template>

<!-- IFF -->
<!--
<xsl:template match="APPLY[CONST[attribute::uri='cic:/coq/INIT/Logic/Equivalence/iff.ind'] and (count(child::*) = 3)]" mode="noannot">
    <m:apply helm:xref="{@id}">
    <m:iff definitionURL="{CONST/@uri}" helm:xref="{CONST/@id}"/>
     <xsl:apply-templates select="*[2]" mode="noannot"/>
     <xsl:apply-templates select="*[3]" mode="noannot"/>
    </m:apply>
</xsl:template>
-->

<!-- EXISTS -->

<xsl:template match="APPLY[MUTIND[attribute::uri='cic:/coq/INIT/Logic/First_order_quantifiers/ex.ind' or attribute::uri='cic:/coq/INIT/Logic_Type/exT.ind'] and (count(child::*) = 3)]" mode="noannot">
    <m:apply helm:xref="{@id}">
     <m:exists definitionURL="{MUTIND/@uri}" helm:xref="{MUTIND/@id}"/>
     <xsl:choose>
      <xsl:when test="name(*[3]) = 'LAMBDA'">
       <m:bvar>
        <m:ci><xsl:value-of select="LAMBDA/target/@binder"/></m:ci>
       </m:bvar>
       <xsl:apply-templates select="LAMBDA/target" mode="noannot"/>
      </xsl:when>
      <xsl:otherwise>
       <m:bvar>
        <m:ci>$x</m:ci>
       </m:bvar>
       <m:apply>
        <m:csymbol>app</m:csymbol>
        <xsl:apply-templates select="*[3]" mode="noannot"/>
        <m:ci>$x</m:ci>
       </m:apply>
      </xsl:otherwise>
     </xsl:choose>
    </m:apply>
</xsl:template>

<xsl:template match="APPLY[MUTIND[attribute::uri='cic:/coq/INIT/Logic/First_order_quantifiers/ex2.ind' or attribute::uri='cic:/coq/INIT/Logic_Type/exT2.ind'] and (count(child::*) = 4)]" mode="noannot">
    <m:apply helm:xref="{@id}">
    <m:exists definitionURL="{MUTIND/@uri}" helm:xref="{MUTIND/@id}"/>
     <xsl:choose>
      <xsl:when test="name(*[3]) = 'LAMBDA'">
       <xsl:variable name="bvarname" select="*[3]/target/@binder"/>
       <m:bvar>
        <m:ci><xsl:value-of select="$bvarname"/></m:ci>
       </m:bvar>
       <m:condition>
        <xsl:apply-templates select="LAMBDA[1]/target" mode="noannot"/>
       </m:condition>
       <xsl:choose>
        <xsl:when test="(name(*[4]) = 'LAMBDA') and 
           ($bvarname = *[4]/target/@binder)">
         <xsl:apply-templates select="LAMBDA[2]/target" mode="noannot"/>
        </xsl:when>
        <xsl:otherwise>
         <m:apply>
          <m:csymbol>app</m:csymbol>
          <xsl:apply-templates select="*[4]" mode="noannot"/>
          <m:ci><xsl:value-of select="$bvarname"/></m:ci>
         </m:apply>
        </xsl:otherwise>
       </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
       <xsl:choose>
        <xsl:when test="name(*[4]) = 'LAMBDA'">
         <xsl:variable name="bvarname" select="*[4]/target/@binder"/>
         <m:bvar>
          <m:ci><xsl:value-of select="$bvarname"/></m:ci>
         </m:bvar>
         <m:condition>
          <m:apply>
           <m:csymbol>app</m:csymbol>
           <xsl:apply-templates select="*[3]" mode="noannot"/>
           <m:ci><xsl:value-of select="$bvarname"/></m:ci>
          </m:apply>
         </m:condition>
         <xsl:apply-templates select="*[4]/target" mode="noannot"/>
        </xsl:when>
        <xsl:otherwise>
         <m:bvar>
          <m:ci>x</m:ci>
         </m:bvar>
         <m:condition>
          <m:apply>
           <m:csymbol>app</m:csymbol>
           <xsl:apply-templates select="*[3]" mode="noannot"/>
           <m:ci>x</m:ci>
          </m:apply>
         </m:condition>
         <m:apply>
          <m:csymbol>app</m:csymbol>
          <xsl:apply-templates select="*[4]" mode="noannot"/>
          <m:ci>x</m:ci>
         </m:apply>
        </xsl:otherwise>
       </xsl:choose>
      </xsl:otherwise>
     </xsl:choose>
    </m:apply>
</xsl:template>

<!-- EQUALITY -->

<xsl:template match="APPLY[MUTIND[attribute::uri='cic:/coq/INIT/Logic/Equality/eq.ind'] and (count(child::*) = 4)]" mode="noannot">
    <m:apply helm:xref="{@id}">
    <m:eq definitionURL="{MUTIND/@uri}" helm:xref="{MUTIND/@id}"/>
     <xsl:apply-templates select="*[3]" mode="noannot"/>
     <xsl:apply-templates select="*[4]" mode="noannot"/>
    </m:apply>
</xsl:template>


<!-- TYPE EQUALITY -->

<xsl:template match="APPLY[MUTIND[attribute::uri='cic:/coq/INIT/Logic_Type/eqT.ind'] and (count(child::*) = 4)]" mode="noannot">
    <m:apply helm:xref="{@id}">
    <m:eq definitionURL="{MUTIND/@uri}" helm:xref="{MUTIND/@id}"/>
     <xsl:apply-templates select="*[3]" mode="noannot"/>
     <xsl:apply-templates select="*[4]" mode="noannot"/>
    </m:apply>
</xsl:template>

<!-- NOT-EQ -->
<!-- NOT and EQ have no parameters -->
<xsl:template match="APPLY[CONST[attribute::uri='cic:/coq/INIT/Logic/not.con']
and (count(child::*) = 2) and APPLY[MUTIND[attribute::uri='cic:/coq/INIT/Logic/Equality/eq.ind']]]" mode="noannot">
    <xsl:choose>
     <xsl:when test="count(APPLY/child::*) = 4">
      <m:apply helm:xref="{@id}">
       <m:neq/>
       <xsl:apply-templates select="*[2]/*[3]" mode="noannot"/>
       <xsl:apply-templates select="*[2]/*[4]" mode="set"/>  
      </m:apply>
     </xsl:when>
     <xsl:otherwise>
      <xsl:apply-imports/>
     </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<!-- NOT-EQT -->
<xsl:template match="APPLY[CONST[attribute::uri='cic:/coq/INIT/Logic/not.con']
and (count(child::*) = 2) and APPLY[MUTIND[attribute::uri='cic:/coq/INIT/Logic_Type/eqT.ind']]]" mode="noannot">
    <xsl:choose>
     <xsl:when test="count(APPLY/child::*) = 4">
      <m:apply helm:xref="{@id}">
       <m:neq/>
       <xsl:apply-templates select="*[2]/*[3]" mode="noannot"/>
       <xsl:apply-templates select="*[2]/*[4]" mode="set"/>  
      </m:apply>
     </xsl:when>
     <xsl:otherwise>
      <xsl:apply-imports/>
     </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<!-- ************************ DATATYPES ******************************* -->

<!-- no datatypes in MathML content -->


<!-- *************************** PEANO ********************************* -->

<xsl:template match="APPLY[MUTIND[attribute::uri='cic:/coq/INIT/Peano/le.ind'] and (count(child::*) = 3)]" mode="noannot">
    <m:apply helm:xref="{@id}">
    <m:leq definitionURL="{MUTIND/@uri}" helm:xref="{MUTIND/@id}"/>
     <xsl:apply-templates select="*[2]" mode="noannot"/>
     <xsl:apply-templates select="*[3]" mode="noannot"/>
    </m:apply>
</xsl:template>

<xsl:template match="APPLY[CONST[attribute::uri='cic:/coq/INIT/Peano/lt.con'] and (count(child::*) = 3)]" mode="noannot">
    <m:apply helm:xref="{@id}">
    <m:lt definitionURL="{CONST/@uri}" helm:xref="{CONST/@id}"/>
     <xsl:apply-templates select="*[2]" mode="noannot"/>
     <xsl:apply-templates select="*[3]" mode="noannot"/>
    </m:apply>
</xsl:template>

<xsl:template match="APPLY[CONST[attribute::uri='cic:/coq/INIT/Peano/ge.con'] and (count(child::*) = 3)]" mode="noannot">
    <m:apply helm:xref="{@id}">
    <m:geq definitionURL="{CONST/@uri}" helm:xref="{CONST/@id}"/>
     <xsl:apply-templates select="*[2]" mode="noannot"/>
     <xsl:apply-templates select="*[3]" mode="noannot"/>
    </m:apply>
</xsl:template>

<xsl:template match="APPLY[CONST[attribute::uri='cic:/coq/INIT/Peano/gt.con'] and (count(child::*) = 3)]" mode="noannot">
    <m:apply helm:xref="{@id}">
    <m:gt definitionURL="{CONST/@uri}" helm:xref="{CONST/@id}"/>
     <xsl:apply-templates select="*[2]" mode="noannot"/>
     <xsl:apply-templates select="*[3]" mode="noannot"/>
    </m:apply>
</xsl:template>

</xsl:stylesheet>






